#include <stdlib.h>
#include <iostream>
#include <string.h>
#include "measure.hh"

// calculate sum with one index variable
int sum0(int* aArray, int aSize) {
  int lSum = 0;
  for(int i = 0; i < aSize; ++i) {
    lSum += aArray[i];
  }
  return lSum;
}

// calculate sum with two index variables
int sum1(int* aArray, int aSize) {
  int lHalf = aSize/2;
  int lSum = 0, lSum1 = 0, lSum2 = 0;
  for(int i = 0; i < lHalf; ++i) {
    lSum1 += aArray[i];
    lSum2 += aArray[i+lHalf];
  }

  lSum = lSum1 + lSum2;

  if(aSize & 0x1) {
    lSum += aArray[aSize-1];
  }
  return lSum;
}

// fill input array with random values from [0,1]
void fillArray(int* aArray, int aSize) {
  for (int i = 0; i < aSize; ++i) {
    aArray[i] = rand() % 2;;   
  }
}

int main(int argc, char* argv[]) {
  // call sum1()?
  bool lSum1 = false;
  // number of runs
  int lIterations = 1;
  int lSize = 100000000;

  if (argc > 1) {
    for (int i = 1; i < argc; ++i) {
      if (!strcmp(argv[i], "-n")) {
        lSize = atol(argv[++i]);
      }   

      if (!strcmp(argv[i], "-i")) {
        lIterations = atol(argv[++i]);
      }

      if (!strcmp(argv[i], "-s1")) {
        lSum1 = true;
      }
    }   
  }

  int * lArray = new int[lSize];
  fillArray(lArray, lSize);

  // measure runtime for sum1 
  Measure lMeasure;
  if (lSum1) {
    lMeasure.start();
    for (int i = 0; i < lIterations; ++i) {
      sum1(lArray, lSize);
    }
    lMeasure.stop();
  }
  // measure runtime for sum0
  else {
    lMeasure.start();
    for (int i = 0; i < lIterations; ++i) {
      sum0(lArray, lSize);
    }
    lMeasure.stop();
  }

  // print runtime
  std::cout << "sum" << (lSum1?"1: ":"0: ") << (float)(lMeasure.mCpuTime()/lIterations) << "s" << std::endl;

  delete[] lArray;

  return 0;
}
